# FLUX 2 Lora API

> FLUX 2 متن سے تصویر، جو انداز یا فائن ٹیونڈ شکل کے لیے زیادہ سے زیادہ 3 حسبِ ضرورت LoRA وزن لاگو کرتا ہے

`loras` میں دیے گئے LoRA وزن لاگو کرتے ہوئے پرامپٹ سے تصاویر بناتا ہے؛ زیادہ سے زیادہ 3، URL، repo ID یا path کے طور پر۔ کنٹرولز میں `guidance_scale` (0 سے 20)، 4 سے 50 اِنفرنس مراحل، `acceleration` لیول اور اختیاری پرامپٹ توسیع شامل ہیں۔ jpeg، png یا webp میں زیادہ سے زیادہ 4 تصاویر بناتا ہے۔

- Model id: `flux-2/lora`
- Made by: Black Forest Labs
- Category: Text to Image
- Output: image
- Price: $0.021 / megapixel (cheapest run $0.021 (21 API credits))
- Run: `POST https://api.doitong.com/v1/run/flux-2/lora`
- Quote: `POST https://api.doitong.com/v1/quote/flux-2/lora`
- Docs page: https://doitong.com/ur/developers/models/flux-2/lora

## Pricing

Price: **$0.021 / megapixel**. Billed per megapixel of output (width × height of every image). Each image is rounded up to a whole megapixel.

The full example input below costs $0.021 = 21 API credits (1 MP × 21 API credits).

Prices are the upstream price in USD, paid from the API balance in API credits (1000 API credits = 1 USD). `POST https://api.doitong.com/v1/quote/flux-2/lora` with the same JSON body returns the exact price for that input; the quote is exactly what a run charges. Invalid input is never charged and failed or canceled requests are refunded automatically.

## Input parameters

Send either the canonical name or the native field name (not both). Canonical names are the same across models.

| Parameter | Canonical name | Type | Required | Default | Allowed values / range | Description |
|---|---|---|---|---|---|---|
| `prompt` |  | string | yes |  |  | تصویر کی تخلیق کی رہنمائی کرنے والا پرامپٹ۔ |
| `guidance_scale` |  | number | no | `2.5` | 0 – 20 | متعلقہ تصویر تلاش کر کے دکھانے کے لیے ماڈل کی پرامپٹ سے مطابقت کی ترتیب، guidance scale کے طور پر ظاہر کی جاتی ہے۔ |
| `seed` |  | integer \| null | no |  |  | تخلیق کے seed کو اوور رائٹ کرتا ہے؛ اسے چھوڑنے سے تخلیق تصادفی طور پر seed منتخب کرتی ہے۔ |
| `num_inference_steps` |  | integer | no | `28` | 4 – 50 | چلائے جانے والے inference steps کی تعداد۔ |
| `image_size` |  | object {width, height} \| enum (string) | no | `landscape_4_3` | `square_hd`, `square`, `portrait_4_3`, `portrait_16_9`, `landscape_4_3`, `landscape_16_9` | آؤٹ پٹ تصویر کا سائز، ہر axis پر کم از کم 512 اور زیادہ سے زیادہ 2048 pixels تک محدود۔ |
| `num_images` | `num_outputs` | integer | no | `1` | 1 – 4 | تخلیق کے لیے مطلوبہ تصاویر کی تعداد۔ |
| `acceleration` |  | enum (string) | no | `regular` | `none`, `regular`, `high` | تصاویر تخلیق کرنے کے لیے acceleration سیٹنگ۔ |
| `enable_prompt_expansion` |  | boolean | no | `false` |  | خودکار پرامپٹ enhancement: true نتائج بہتر بنانے کے لیے پرامپٹ کو وسعت دیتا ہے۔ |
| `enable_safety_checker` |  | boolean | no | `true` |  | حفاظتی جانچ، جو غیر محفوظ قرار دی گئی تصاویر کی جگہ سیاہ تصاویر واپس کرتی ہے۔ true جانچ فعال کرتا ہے؛ false اسے صرف مجاز اکاؤنٹس کے لیے غیر فعال کرتا ہے، جبکہ بغیر اجازت درخواستوں کی جانچ بہرحال ہوتی ہے۔ |
| `output_format` |  | enum (string) | no | `png` | `jpeg`, `png`, `webp` | نتیجہ خیز تصویر کا فائل فارمیٹ۔ |
| `loras` |  | array of object {path, scale} | no | `[]` |  | ان کے مقامات کو URLs، HuggingFace repository IDs، یا مقامی paths کے طور پر درج کرکے زیادہ سے زیادہ 3 LoRA weights لاگو کریں۔ |
| `loras[].path` |  | string | yes |  |  | LoRA weights کا مقام، URL، owner/repo شکل میں HuggingFace repository ID، یا مقامی path کے طور پر متعین کیا جاتا ہے۔ |
| `loras[].scale` |  | number | no | `1` | 0 – 4 | LoRA پر لاگو کیا جانے والا scaling factor، 0.0 سے 4.0 تک۔ |

## Example input

Required parameters only:

```json
{
  "prompt": "A red fox trots through fresh snow at sunrise, soft golden light, shallow depth of field"
}
```

A fuller example:

```json
{
  "prompt": "A red fox trots through fresh snow at sunrise, soft golden light, shallow depth of field"
}
```

## Run it

Set `DOITONG_API_KEY` to a key from https://doitong.com/developers/dashboard#keys. `?wait=20` returns the finished request in the same call when it is ready within 20 seconds; otherwise poll `GET /requests/{id}` (it also accepts `?wait=`), or pass `webhook_url`.

### curl

```bash
# Run the model; wait up to 20 s for the finished result in the same call
curl -X POST "https://api.doitong.com/v1/run/flux-2/lora?wait=20" \
  -H "Authorization: Bearer $DOITONG_API_KEY" \
  -H "Content-Type: application/json" \
  -d '{
    "prompt": "A red fox trots through fresh snow at sunrise, soft golden light, shallow depth of field"
  }'

# Still "queued" or "running"? Poll with the id from the response:
curl "https://api.doitong.com/v1/requests/REQUEST_ID?wait=20" \
  -H "Authorization: Bearer $DOITONG_API_KEY"
```

### JavaScript

```javascript
const API = "https://api.doitong.com/v1";
const headers = {
  "Authorization": "Bearer " + process.env.DOITONG_API_KEY,
  "Content-Type": "application/json",
};

// Run the model; wait up to 20 s for the finished result in the same call
let res = await fetch(API + "/run/flux-2/lora?wait=20", {
  method: "POST",
  headers,
  body: JSON.stringify({
    "prompt": "A red fox trots through fresh snow at sunrise, soft golden light, shallow depth of field"
  }),
});
let request = await res.json();
if (!res.ok) throw new Error(request.error.code + ": " + request.error.message);

// Not finished yet: long-poll until it is
while (request.status === "queued" || request.status === "running") {
  res = await fetch(API + "/requests/" + request.id + "?wait=20", { headers });
  request = await res.json();
}
if (request.status !== "succeeded") throw new Error(JSON.stringify(request.error));
console.log(request.outputs.map((o) => o.url), request.cost.credits + " API credits ($" + request.cost.usd + ")");
```

### Python

```python
import os
import requests

API = "https://api.doitong.com/v1"
headers = {"Authorization": "Bearer " + os.environ["DOITONG_API_KEY"]}

payload = {
    "prompt": "A red fox trots through fresh snow at sunrise, soft golden light, shallow depth of field",
}

# Run the model; wait up to 20 s for the finished result in the same call
r = requests.post(API + "/run/flux-2/lora", params={"wait": 20}, json=payload, headers=headers)
request = r.json()
if not r.ok:
    raise RuntimeError(request["error"]["code"] + ": " + request["error"]["message"])

# Not finished yet: long-poll until it is
while request["status"] in ("queued", "running"):
    request = requests.get(API + "/requests/" + request["id"], params={"wait": 20}, headers=headers).json()
if request["status"] != "succeeded":
    raise RuntimeError(request["error"])
print([o["url"] for o in request["outputs"]], request["cost"]["credits"], "API credits", "$" + request["cost"]["usd"])
```

### MCP

The MCP server at `https://api.doitong.com/v1/mcp` exposes the tools `search_models`, `get_model`, `quote`, `run`, `get_request`, `cancel_request`, `list_requests`, `create_upload` and `get_account`. A `run` call for this model:

```json
{
  "jsonrpc": "2.0",
  "id": 1,
  "method": "tools/call",
  "params": {
    "name": "run",
    "arguments": {
      "model_id": "flux-2/lora",
      "input": {
        "prompt": "A red fox trots through fresh snow at sunrise, soft golden light, shallow depth of field"
      },
      "wait_seconds": 20
    }
  }
}
```

## Response

Every call returns a request object. `status` is one of `queued`, `running`, `succeeded`, `failed`, `canceled`. `outputs` lists the generated files with URLs on our storage (kept forever, or 7 days with `?storage=temporary`; `storage` says which); `output` is the model's own result object with the same URLs.

```json
{
  "id": "req_8k2m4q7x1z9c3v5b6n0p2r4t",
  "object": "request",
  "model": "flux-2/lora",
  "status": "succeeded",
  "created_at": "2026-10-20T12:00:00Z",
  "started_at": "2026-10-20T12:00:02Z",
  "completed_at": "2026-10-20T12:00:09Z",
  "queue_position": null,
  "cost": {
    "credits": 21,
    "usd": "0.021",
    "charged": 21,
    "refunded": 0
  },
  "input": {
    "prompt": "A red fox trots through fresh snow at sunrise, soft golden light, shallow depth of field"
  },
  "output": {
    "images": [
      {
        "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.jpeg",
        "content_type": "image/jpeg",
        "file_name": "0-output.jpeg",
        "file_size": 1843200,
        "width": 1024,
        "height": 768
      }
    ],
    "timings": {},
    "seed": 42,
    "has_nsfw_concepts": [
      false
    ],
    "prompt": "string"
  },
  "outputs": [
    {
      "type": "image",
      "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.jpeg",
      "content_type": "image/jpeg",
      "file_size": 1843200,
      "width": 1024,
      "height": 768,
      "stored": true
    }
  ],
  "error": null,
  "metrics": {
    "inference_seconds": 6.8
  },
  "urls": {
    "self": "https://api.doitong.com/v1/requests/req_8k2m4q7x1z9c3v5b6n0p2r4t",
    "cancel": "https://api.doitong.com/v1/requests/req_8k2m4q7x1z9c3v5b6n0p2r4t/cancel"
  }
}
```

### Output fields (`output`)

| Field | Type | Description |
|---|---|---|
| `images` | array of object {url, content_type, file_name, file_size, width, height} | ماڈل سے تیار کردہ تصاویر۔ |
| `timings` | object |  |
| `seed` | integer | تصویر کی تخلیق کا سیڈ، جس میں ان پٹ میں سیڈ نہ دینے پر تصادفی طور پر منتخب قدر شامل ہوتی ہے؛ بصورتِ دیگر فراہم کردہ قدر دہرائی جاتی ہے۔ |
| `has_nsfw_concepts` | array of boolean | بتاتا ہے کہ تخلیق کردہ تصاویر میں NSFW تصورات موجود ہیں یا نہیں۔ |
| `prompt` | string | تصویر کی تخلیق کے دوران استعمال ہونے والا پرامپٹ۔ |

## Related models

- [FLUX 2 Flash](https://doitong.com/developers/models/flux-2/flash.md) (`flux-2/flash`): $0.005 / megapixel
- [FLUX 2 Turbo](https://doitong.com/developers/models/flux-2/turbo.md) (`flux-2/turbo`): $0.008 / megapixel
- [FLUX.2 \[dev\]](https://doitong.com/developers/models/flux-2.md) (`flux-2`): $0.012 / megapixel
- [FLUX.2 \[pro\]](https://doitong.com/developers/models/flux-2-pro.md) (`flux-2-pro`): $0.015 / megapixel of output image
- [FLUX 2 Edit](https://doitong.com/developers/models/flux-2/edit.md) (`flux-2/edit`): $0.012 / megapixel
- [FLUX 2 Flash Edit](https://doitong.com/developers/models/flux-2/flash/edit.md) (`flux-2/flash/edit`): $0.005 / megapixel
- [FLUX 2 Lora Edit](https://doitong.com/developers/models/flux-2/lora/edit.md) (`flux-2/lora/edit`): $0.021 / megapixel
- [FLUX 2 Pro Edit](https://doitong.com/developers/models/flux-2-pro/edit.md) (`flux-2-pro/edit`): $0.105 / run

## Links

- HTML page: https://doitong.com/developers/models/flux-2/lora
- All models and guides for AI agents: https://doitong.com/developers/llms.txt
- OpenAPI 3.1 with this model's typed request body: https://doitong.com/developers/openapi.json?model=flux-2/lora
- Errors: https://doitong.com/developers/docs/errors
- Model details as JSON: https://api.doitong.com/v1/models/flux-2/lora
